/*  OpenOlap viewer
 *  パッケージ名：openolap.viewer
 *  ファイル：Controller.java
 *  説明：クライアントからの要求を処理するServletクラスです。
 *
 *  作成日: 2004/01/05
 */

package openolap.viewer.controller;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import openolap.viewer.common.CommonSettings;

/**
 * クラス：Controller
 * 説明：コマンドをあらわすインターフェースです。
 */
public class Controller extends HttpServlet {

	// ********** メソッド **********

	/**
	 * サーブレットの初期化処理を行う。
	 * @param config ServletConfigオブジェクト
	 * @exception ServletException Servletの初期化処理で例外が発生した
	 */
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}

	/**
	 * サーブレットの終了処理を行う。
	 */
	public void destroy() {
	}

	/**
	 * HTTPリクエストを受けて処理を実行する。
	 * @param request HttpServletRequestオブジェクト
	 * @param response HttpServletResponseオブジェクト
	 * @exception ServletException 処理中に例外が発生した
	 * @exception IOException 処理中に例外が発生した
	 */
	protected void processRequest(
		HttpServletRequest request,HttpServletResponse response) 
		throws ServletException,java.io.IOException {

		// 初期化
		ServletContext context = getServletConfig().getServletContext();
		if ( context.getAttribute("apCommonSettings") == null ) {
			InitializeStatus.initApStatus(context);
		}

		// 文字コード設定
		request.setCharacterEncoding("Shift_JIS");


		String page;
		try {
			// 呼び出す業務処理を選択
			RequestHelper helper = new RequestHelper(request, response, getServletConfig());
			Command command = helper.getCommand();
	
			if (command == null) { throw new IllegalStateException(); }
			if (context == null) { throw new IllegalStateException();	}

			// 業務処理呼び出し
			page = command.execute(helper, (CommonSettings) context.getAttribute("apCommonSettings"));
		} catch(Exception e) {
			e.printStackTrace();
			return;
		}

			//制御をリクエストに対応するページにディスパッチする
			if(page != null) {
				dispatch(request,response,page);
			}

	}

	/**
	 * HTTP GETをハンドリングする。
	 * @param request HttpServletRequestオブジェクト
	 * @param response HttpServletResponseオブジェクト
	 * @exception ServletException 処理中に例外が発生した
	 * @exception IOException 処理中に例外が発生した
	 */
	protected void doGet(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException {

		processRequest(request,response);
	}

	/**
	 * HTTP POSTをハンドリングする。
	 * @param request HttpServletRequestオブジェクト
	 * @param response HttpServletResponseオブジェクト
	 * @exception ServletException 処理中に例外が発生した
	 * @exception IOException 処理中に例外が発生した
	 */
	protected void doPost(
		HttpServletRequest request,
		HttpServletResponse response)
		throws ServletException, IOException {

		processRequest(request,response);
	}

	/**
	 * JSP/HTMLへのdispatch処理を実行する。
	 * @param request HttpServletRequestオブジェクト
	 * @param response HttpServletResponseオブジェクト
	 * @param page dispatch先のJSP/HTMLへのパス
	 * @exception ServletException 処理中に例外が発生した
	 * @exception IOException 処理中に例外が発生した
	 */
	protected void dispatch(
		HttpServletRequest request,
		HttpServletResponse response,
		String page) 
		throws ServletException,java.io.IOException {

		RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(page);
		dispatcher.forward(request,response);
	}

}
